<template>
    <v-row>
        <v-col cols="12" md="6" lg="6" xl="6">
            <v-card v-for="user in users" :key="user._id" class="ma-5 pa-5">
                <div v-if="me !== undefined && user._id === me._id">
                    <v-card-title>
                        {{ $t('settings.me') }}
                    </v-card-title>
                    <v-card-text>
                        <v-text-field
                            v-model="state.name"
                            :label="$t('settings.name')"
                            outlined
                            prepend-inner-icon="mdi-account-edit"
                        />
                        <v-text-field
                            v-model="state.id"
                            label="ID"
                            outlined
                            disabled
                            prepend-inner-icon="mdi-card-account-details-outline"
                        />
                    </v-card-text>
                    <v-divider />
                    <v-card-actions>
                        <v-btn
                            color="primary"
                            icon
                            @click="state.saveSelf()"
                        >
                            <v-icon>mdi-content-save-outline</v-icon>
                        </v-btn>
                        <v-btn
                            color="primary"
                            icon
                            @click="makeQR(userModel.nodeId)"
                        >
                            <v-icon>mdi-qrcode</v-icon>
                        </v-btn>
                        <v-btn
                            icon
                            color="primary"
                            @click="onCopy(userModel.nodeId)"
                        >
                            <v-icon>mdi-content-copy</v-icon>
                        </v-btn>
                        <v-btn
                            icon
                            color="primary"
                            @click="showAddPeerDialog = true"
                        >
                            <v-icon>mdi-account-plus-outline</v-icon>
                        </v-btn>
                    </v-card-actions>
                    <v-dialog
                        v-model="showAddPeerDialog"
                        width="500"
                    >
                        <v-card>
                            <v-card-title class="text-h5 grey lighten-2">
                                {{ $t('settings.peerId') }}
                            </v-card-title>
                            <v-spacer></v-spacer>
                            <v-card-text class="mt-3">
                                <v-text-field
                                    v-model="peerId"
                                    dense
                                    outlined
                                    clearable
                                    type="text"
                                    :label="$t('settings.peerId')"
                                    prepend-inner-icon="mdi-account-multiple"
                                    value=""
                                ></v-text-field>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn
                                    color="primary"
                                    text
                                    @click="showAddPeerDialog= false"
                                >
                                    {{ $t('settings.cancel') }}
                                </v-btn>
                                <v-btn
                                    color="primary"
                                    icon
                                    @click="state.addPeer(peerId)"
                                >
                                    <v-icon>mdi-human-greeting-proximity</v-icon>
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </div>
                <div v-else>
                    <v-card-title>
                        {{ $t('settings.peer') }}
                    </v-card-title>
                    <v-card-text>
                        <v-text-field
                            v-model="user.name"
                            :label="$t('settings.name')"
                            outlined
                            disabled
                            prepend-inner-icon="mdi-account-multiple"
                        />
                        <v-text-field
                            v-model="user._id"
                            label="ID"
                            outlined
                            disabled
                            prepend-inner-icon="mdi-card-account-details-outline"
                        />
                    </v-card-text>
                    <v-divider />
                    <v-card-actions>
                        <v-btn
                            color="error"
                            icon
                            @click="userModel.removeUser(user._id)"
                        >
                            <v-icon>mdi-trash-can-outline</v-icon>
                        </v-btn>
                    </v-card-actions>
                </div>
            </v-card>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Inject, Vue } from 'vue-property-decorator'
import { Observer } from "mobx-vue"
import { SettingsModel } from '@/store/modules/settings';
import { UserModel } from '@/store/modules/user';
import { RootStore } from "@/store"

@Observer
@Component({})
export default class Settings extends Vue {
    @Inject("root") root !: RootStore
    @Inject("userModel") userModel!: UserModel
    private state: SettingsModel = new SettingsModel(this.userModel)
    private showAddPeerDialog: boolean = false
    private peerId: string = ""

    get me() {
        if (this.userModel.me !== undefined) this.state.init();
        return this.userModel.me;
    }

    get users() {
        return this.userModel._users;
    }
    private onCopy(nodeId: string) {
        navigator.clipboard.writeText(nodeId);
    }

    private makeQR(nodeId: string) {
        console.log("Implement QR > ", nodeId);
    }

    private addUser() {
        this.showAddPeerDialog = true;
    }
}
</script>
